#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>

const char* ssid = "FRITZBox7590GI24"; //SSID aus dem Router
const char* password = "22894580214767401850"; //Passwort für den Zugang zum WLAN

ESP8266WebServer server(80); //Port auf welchem der Server laufen soll.

String pixels[40];

void setup() {
  delay(10); //10ms. Warten damit die Seriele Kommunikation aufgebaut wurde.
  Serial.begin(9600);
  WiFi.begin(ssid, password); //Initialisieren der Wifi Verbindung.

  while (WiFi.status() != WL_CONNECTED) { //Warten bis die Verbindung aufgebaut wurde.
    delay(500);
  }

  server.on("/sk6812", callHandleSK6812Shield);

  server.begin(); // Starten des Servers.
}

void loop() {
  server.handleClient();
}

void callHandleSK6812Shield() {
  boolean doReset = false;
  for (int i = 0; i < server.args(); i++) {

    String parameterName = server.argName(i);
    String parameterValue = server.arg(i);
    //Wenn der Parametername gleich "text" ist dann...

    if (parameterName == "reset") {
      doReset = true;
      break;
    }

    if (parameterName != "test") {
      pixels[i - 1] = parameterValue;
    }
  }
  sendResult();

  if (doReset) {
    Serial.println("reset");
  } else {
    sendSerialCommands();
  }
}



//Diese Funktion sendet eine Antwort an den Client.
void sendResult() {
  //200 ist die Antwort das alles OK ist,
  //text/html ist der MimeType
  //content ist unser Text
  server.send(200, "text/html", "OK");
}

void sendSerialCommands() {
  for (int i = 0; i < 40; i++) {
    if (pixels[i] != "000000000") {

      String line = "";
      if (i < 10) {
        line += "0";
      }
      line += String(i);
      line += "-";
      line += pixels[i];
      Serial.println(line);
    }
  }

}
